<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang xml:lang>
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>First Steps with TileDB</title>
  <style>
    code{white-space: pre-wrap;}
    span.smallcaps{font-variant: small-caps;}
    span.underline{text-decoration: underline;}
    div.column{display: inline-block; vertical-align: top; width: 50%;}
    div.hanging-indent{margin-left: 1.5em; text-indent: -1.5em;}
    ul.task-list{list-style: none;}
    pre > code.sourceCode { white-space: pre; position: relative; }
    pre > code.sourceCode > span { display: inline-block; line-height: 1.25; }
    pre > code.sourceCode > span:empty { height: 1.2em; }
    .sourceCode { overflow: visible; }
    code.sourceCode > span { color: inherit; text-decoration: inherit; }
    div.sourceCode { margin: 1em 0; }
    pre.sourceCode { margin: 0; }
    @media screen {
    div.sourceCode { overflow: auto; }
    }
    @media print {
    pre > code.sourceCode { white-space: pre-wrap; }
    pre > code.sourceCode > span { text-indent: -5em; padding-left: 5em; }
    }
    pre.numberSource code
      { counter-reset: source-line 0; }
    pre.numberSource code > span
      { position: relative; left: -4em; counter-increment: source-line; }
    pre.numberSource code > span > a:first-child::before
      { content: counter(source-line);
        position: relative; left: -1em; text-align: right; vertical-align: baseline;
        border: none; display: inline-block;
        -webkit-touch-callout: none; -webkit-user-select: none;
        -khtml-user-select: none; -moz-user-select: none;
        -ms-user-select: none; user-select: none;
        padding: 0 4px; width: 4em;
        color: #aaaaaa;
      }
    pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
    div.sourceCode
      {   }
    @media screen {
    pre > code.sourceCode > span > a:first-child::before { text-decoration: underline; }
    }
    code span.al { color: #ff0000; font-weight: bold; } /* Alert */
    code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
    code span.at { color: #7d9029; } /* Attribute */
    code span.bn { color: #40a070; } /* BaseN */
    code span.bu { color: #008000; } /* BuiltIn */
    code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
    code span.ch { color: #4070a0; } /* Char */
    code span.cn { color: #880000; } /* Constant */
    code span.co { color: #60a0b0; font-style: italic; } /* Comment */
    code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
    code span.do { color: #ba2121; font-style: italic; } /* Documentation */
    code span.dt { color: #902000; } /* DataType */
    code span.dv { color: #40a070; } /* DecVal */
    code span.er { color: #ff0000; font-weight: bold; } /* Error */
    code span.ex { } /* Extension */
    code span.fl { color: #40a070; } /* Float */
    code span.fu { color: #06287e; } /* Function */
    code span.im { color: #008000; font-weight: bold; } /* Import */
    code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
    code span.kw { color: #007020; font-weight: bold; } /* Keyword */
    code span.op { color: #666666; } /* Operator */
    code span.ot { color: #007020; } /* Other */
    code span.pp { color: #bc7a00; } /* Preprocessor */
    code span.sc { color: #4070a0; } /* SpecialChar */
    code span.ss { color: #bb6688; } /* SpecialString */
    code span.st { color: #4070a0; } /* String */
    code span.va { color: #19177c; } /* Variable */
    code span.vs { color: #4070a0; } /* VerbatimString */
    code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
    .display.math{display: block; text-align: center; margin: 0.5rem auto;}
  </style>
  <style type="text/css">
body {
max-width: 50rem;
margin-left: auto;
margin-right: auto;
font-family: system-ui;
}

code {
padding: 2px;
border-radius: unset;
}

pre {
background-color: unset;
border: solid #aaa 1px;
padding: 8px;
}
pre.numberSource {
margin: 0;
padding-left: 0;
}
div.sourceCode {
overflow: visible;
}
pre, pre.sourceCode {
overflow-x: auto;
}
pre>code {
white-space: pre;
overflow: visible;
background-color: unset;
padding: 0;
}
pre.sourceCode.numberSource {
overflow-x: visible;
}
pre.sourceCode.numberSource>code {
white-space: pre-wrap
}
pre.sourceCode.numberSource>code>span {
left: 8px;
text-indent: -4.6em;
}

.chunk-summary {
text-align: right;
}
.chunk-summary+pre,
.chunk-summary+div.sourceCode {
margin-top: 2px;
}

nav > ul {
border: .0625rem solid #444;
border-radius: 4px;
margin: 5px;
padding: 5px;
}
nav ul {
list-style-type: none;
padding-inline-start: 1rem;
}
nav ul li {
padding: 0;
}
nav ul ul {
margin-top: 0;
margin-bottom: 0;
padding-top: 0;
padding-bottom: 0;
}
nav code {
background-color: unset;
color: unset;
}
</style>
</head>
<body>
<header id="title-block-header">
<h1 class="title">First Steps with TileDB</h1>
</header>
<!--
%\VignetteIndexEntry{Introduction to TileDB}
%\VignetteEngine{simplermarkdown::mdweave_to_html}
%\VignetteEncoding{UTF-8}
-->
<p>This document introduces TileDB via several simple examples. A
corresponding document with more complete <a href="documentation.html">API documentation</a> is also available.</p>
<h1 id="getting-started">Getting started</h1>
<p>Once the TileDB R package is installed, it can be loaded via
<code>library(tiledb)</code>. Installation is supported for Windows,
Linux and macOS via the <a href="https://cran.r-project.org/package=tiledb">official CRAN
package</a>, on Linux and macOS via the <a href="https://anaconda.org/conda-forge">conda</a> package as well as
from source.</p>
<p>Documentation for the TileDB R package is available via the
<code>help()</code> function from within R as well as via the <a href="https://tiledb-inc.github.io/TileDB-R/">package documentation</a>
and an <a href="https://github.com/TileDB-Inc/TileDB-R/tree/master/inst/notebooks">introductory
notebook</a>. Documentation about TileDB itself is <a href="https://docs.tiledb.com/main/">also available</a>.</p>
<p>Several “quickstart” examples that are discussed on the website are
available in the <a href="https://github.com/TileDB-Inc/TileDB-R/tree/master/inst/examples">examples</a>
directory. This vignette discusses similar examples.</p>
<p>In the following examples, the URIs describing arrays point to local
file system object. When TileDB has been built with S3 support, and with
proper AWS credentials in the usual environment variables, URIs such as
<code>s3://some/data/bucket</code> can be used where a local file would
be used. See the script <a href="https://github.com/TileDB-Inc/TileDB-R/blob/master/inst/examples/ex_S3.R">ex_S3.R</a>
for an example.</p>
<h1 id="dense-arrays">Dense Arrays</h1>
<h2 id="preliminaries">Preliminaries</h2>
<p>These illustrations use the array created by the file <a href="https://github.com/TileDB-Inc/TileDB-R/blob/master/inst/examples/ex_1.R">ex_1.R</a>
which one can run from within R, or on the command-line. To follow along
with discussion that follows, it helps to run the example once to create
the array after possibly adjusting the array location path from its
default value (using the current directory or, if set as an option, an
override).</p>
<h2 id="basic-reading-of-dense-arrays">Basic Reading of Dense
Arrays</h2>
<p>The file <a href="https://github.com/TileDB-Inc/TileDB-R/blob/master/inst/examples/ex_1.R">ex_1.R</a>
in the examples directory is a simple yet complete example extending <a href="https://github.com/TileDB-Inc/TileDB-R/blob/master/inst/examples/quickstart_dense.R">quickstart_dense.R</a>
by adding a second and third attribute. In this as well as the following
examples we will use <code>tiledb_array()</code> to access the array;
the older variants <code>tiledb_dense()</code> and
<code>tiledb_sparse()</code> remain supported but are deprecated and may
be removed at some point in the future.</p>
<p><em>Read 1-D</em></p>
<p>The first example extracts rows 1 to 2 and column 2 from an array. It
also limits the selection to just one attribute (via
<code>attrs</code>), asks for the return to be a <code>data.frame</code>
(instead of a simpler list) and for the (row and column, if present as
here) indices to not be printed (via <code>extended=FALSE</code>).</p>
<div class="sourceCode" id="cb1"><pre class="sourceCode r"><code class="sourceCode r"><span id="cb1-1"><a href="#cb1-1" aria-hidden="true" tabindex="-1"></a><span class="sc">&gt;</span> A <span class="ot">&lt;-</span> <span class="fu">tiledb_array</span>(<span class="at">uri =</span> uri, <span class="at">attrs =</span> <span class="st">&quot;b&quot;</span>,</span>
<span id="cb1-2"><a href="#cb1-2" aria-hidden="true" tabindex="-1"></a><span class="sc">+</span>                   <span class="at">as.data.frame=</span><span class="cn">TRUE</span>, <span class="at">extended=</span><span class="cn">FALSE</span>)<span class="er">)</span></span>
<span id="cb1-3"><a href="#cb1-3" aria-hidden="true" tabindex="-1"></a><span class="sc">&gt;</span> A[<span class="dv">1</span><span class="sc">:</span><span class="dv">2</span>,<span class="dv">2</span>]</span>
<span id="cb1-4"><a href="#cb1-4" aria-hidden="true" tabindex="-1"></a>[<span class="dv">1</span>] <span class="fl">101.5</span> <span class="fl">104.0</span></span>
<span id="cb1-5"><a href="#cb1-5" aria-hidden="true" tabindex="-1"></a><span class="sc">&gt;</span></span></code></pre></div>
<p>Note that the examples create three two-dimensional attributes. The
attributes can be selected via the <code>attrs</code> argument, or the
<code>attrs()</code> method on the array object. The square-bracket
indexing then selects with in the 2-d attribute object.</p>
<p>If multiple objects are returned (as <code>list</code> or
<code>data.frame</code>), subsetting on the returned object works via
<code>[[var]]</code> or <code>$var</code>. A numeric index also works
(but needs to account for <code>rows</code> and <code>cols</code>).</p>
<div class="sourceCode" id="cb2"><pre class="sourceCode r"><code class="sourceCode r"><span id="cb2-1"><a href="#cb2-1" aria-hidden="true" tabindex="-1"></a><span class="sc">&gt;</span> A <span class="ot">&lt;-</span> <span class="fu">tiledb_array</span>(<span class="at">uri =</span> uri, <span class="at">attrs =</span> <span class="fu">c</span>(<span class="st">&quot;a&quot;</span>,<span class="st">&quot;b&quot;</span>),</span>
<span id="cb2-2"><a href="#cb2-2" aria-hidden="true" tabindex="-1"></a><span class="sc">+</span>                   <span class="at">as.data.frame =</span> <span class="cn">TRUE</span>)</span>
<span id="cb2-3"><a href="#cb2-3" aria-hidden="true" tabindex="-1"></a><span class="sc">&gt;</span> A[<span class="dv">1</span><span class="sc">:</span><span class="dv">2</span>,<span class="dv">2</span>][[<span class="st">&quot;a&quot;</span>]]</span>
<span id="cb2-4"><a href="#cb2-4" aria-hidden="true" tabindex="-1"></a>[<span class="dv">1</span>] <span class="dv">2</span> <span class="dv">7</span></span>
<span id="cb2-5"><a href="#cb2-5" aria-hidden="true" tabindex="-1"></a><span class="sc">&gt;</span> A[<span class="dv">1</span><span class="sc">:</span><span class="dv">2</span>,<span class="dv">2</span>]<span class="sc">$</span>a</span>
<span id="cb2-6"><a href="#cb2-6" aria-hidden="true" tabindex="-1"></a>[<span class="dv">1</span>] <span class="dv">2</span> <span class="dv">7</span></span>
<span id="cb2-7"><a href="#cb2-7" aria-hidden="true" tabindex="-1"></a><span class="sc">&gt;</span></span></code></pre></div>
<p><em>Read 2-D</em></p>
<p>This works analogously. Note that the results are generally returned
as vectors, or as a columns of a <code>data.frame</code> object in case
that option was set.</p>
<div class="sourceCode" id="cb3"><pre class="sourceCode r"><code class="sourceCode r"><span id="cb3-1"><a href="#cb3-1" aria-hidden="true" tabindex="-1"></a><span class="sc">&gt;</span> A[<span class="dv">6</span><span class="sc">:</span><span class="dv">9</span>,<span class="dv">3</span><span class="sc">:</span><span class="dv">4</span>]</span>
<span id="cb3-2"><a href="#cb3-2" aria-hidden="true" tabindex="-1"></a><span class="sc">$</span>a</span>
<span id="cb3-3"><a href="#cb3-3" aria-hidden="true" tabindex="-1"></a>[<span class="dv">1</span>] <span class="dv">28</span> <span class="dv">29</span> <span class="dv">33</span> <span class="dv">34</span> <span class="dv">38</span> <span class="dv">39</span> <span class="dv">43</span> <span class="dv">44</span></span>
<span id="cb3-4"><a href="#cb3-4" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb3-5"><a href="#cb3-5" aria-hidden="true" tabindex="-1"></a><span class="sc">$</span>b</span>
<span id="cb3-6"><a href="#cb3-6" aria-hidden="true" tabindex="-1"></a>[<span class="dv">1</span>] <span class="fl">114.5</span> <span class="fl">115.0</span> <span class="fl">117.0</span> <span class="fl">117.5</span> <span class="fl">119.5</span> <span class="fl">120.0</span> <span class="fl">122.0</span> <span class="fl">122.5</span></span>
<span id="cb3-7"><a href="#cb3-7" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb3-8"><a href="#cb3-8" aria-hidden="true" tabindex="-1"></a><span class="sc">$</span>c</span>
<span id="cb3-9"><a href="#cb3-9" aria-hidden="true" tabindex="-1"></a>[<span class="dv">1</span>] <span class="st">&quot;fox&quot;</span> <span class="st">&quot;A&quot;</span>   <span class="st">&quot;E&quot;</span>   <span class="st">&quot;F&quot;</span>   <span class="st">&quot;J&quot;</span>   <span class="st">&quot;K&quot;</span>   <span class="st">&quot;O&quot;</span>   <span class="st">&quot;P&quot;</span></span>
<span id="cb3-10"><a href="#cb3-10" aria-hidden="true" tabindex="-1"></a><span class="sc">&gt;</span></span></code></pre></div>
<h2 id="read-2-d-with-attribute-selection">Read 2-D with attribute
selection</h2>
<p>We can restrict the selection to a subset of attributes when opening
the array.</p>
<div class="sourceCode" id="cb4"><pre class="sourceCode r"><code class="sourceCode r"><span id="cb4-1"><a href="#cb4-1" aria-hidden="true" tabindex="-1"></a><span class="sc">&gt;</span> A <span class="ot">&lt;-</span> <span class="fu">tiledb_dense</span>(<span class="at">uri =</span> uri, <span class="at">attrs =</span> <span class="fu">c</span>(<span class="st">&quot;b&quot;</span>,<span class="st">&quot;c&quot;</span>),</span>
<span id="cb4-2"><a href="#cb4-2" aria-hidden="true" tabindex="-1"></a><span class="sc">+</span>                   <span class="at">as.data.frame =</span> <span class="cn">TRUE</span>, <span class="at">extended=</span><span class="cn">FALSE</span>)</span>
<span id="cb4-3"><a href="#cb4-3" aria-hidden="true" tabindex="-1"></a><span class="sc">&gt;</span> A[<span class="dv">6</span><span class="sc">:</span><span class="dv">9</span>,<span class="dv">2</span><span class="sc">:</span><span class="dv">4</span>]</span>
<span id="cb4-4"><a href="#cb4-4" aria-hidden="true" tabindex="-1"></a>       b     c</span>
<span id="cb4-5"><a href="#cb4-5" aria-hidden="true" tabindex="-1"></a><span class="dv">1</span>  <span class="fl">114.0</span> brown</span>
<span id="cb4-6"><a href="#cb4-6" aria-hidden="true" tabindex="-1"></a><span class="dv">2</span>  <span class="fl">114.5</span>   fox</span>
<span id="cb4-7"><a href="#cb4-7" aria-hidden="true" tabindex="-1"></a><span class="dv">3</span>  <span class="fl">115.0</span>     A</span>
<span id="cb4-8"><a href="#cb4-8" aria-hidden="true" tabindex="-1"></a><span class="dv">4</span>  <span class="fl">116.5</span>     D</span>
<span id="cb4-9"><a href="#cb4-9" aria-hidden="true" tabindex="-1"></a><span class="dv">5</span>  <span class="fl">117.0</span>     E</span>
<span id="cb4-10"><a href="#cb4-10" aria-hidden="true" tabindex="-1"></a><span class="dv">6</span>  <span class="fl">117.5</span>     F</span>
<span id="cb4-11"><a href="#cb4-11" aria-hidden="true" tabindex="-1"></a><span class="dv">7</span>  <span class="fl">119.0</span>     I</span>
<span id="cb4-12"><a href="#cb4-12" aria-hidden="true" tabindex="-1"></a><span class="dv">8</span>  <span class="fl">119.5</span>     J</span>
<span id="cb4-13"><a href="#cb4-13" aria-hidden="true" tabindex="-1"></a><span class="dv">9</span>  <span class="fl">120.0</span>     K</span>
<span id="cb4-14"><a href="#cb4-14" aria-hidden="true" tabindex="-1"></a><span class="dv">10</span> <span class="fl">121.5</span>     N</span>
<span id="cb4-15"><a href="#cb4-15" aria-hidden="true" tabindex="-1"></a><span class="dv">11</span> <span class="fl">122.0</span>     O</span>
<span id="cb4-16"><a href="#cb4-16" aria-hidden="true" tabindex="-1"></a><span class="dv">12</span> <span class="fl">122.5</span>     P</span>
<span id="cb4-17"><a href="#cb4-17" aria-hidden="true" tabindex="-1"></a><span class="sc">&gt;</span></span></code></pre></div>
<p>This also illustrated the effect of setting
<code>as.data.frame=TRUE</code> when opening the array.</p>
<p>This scheme can be generalized to variable cells, or cells where
N&gt;1, as we can expand each (atomistic) value over corresponding row
and column indices.</p>
<p>The column types correspond to the attribute typed in the array
schema, subject to the constraint mentioned above on R types. (The char
comes in as a factor variable as is still the R 3.6.* default which is
about to change. We can also override, users can too.)</p>
<div class="sourceCode" id="cb5"><pre class="sourceCode r"><code class="sourceCode r"><span id="cb5-1"><a href="#cb5-1" aria-hidden="true" tabindex="-1"></a><span class="sc">&gt;</span> A <span class="ot">&lt;-</span> <span class="fu">tiledb_array</span>(<span class="st">&quot;/tmp/tiledb/ex_1/&quot;</span>, <span class="at">attrs=</span><span class="fu">c</span>(<span class="st">&quot;b&quot;</span>,<span class="st">&quot;c&quot;</span>),</span>
<span id="cb5-2"><a href="#cb5-2" aria-hidden="true" tabindex="-1"></a><span class="sc">+</span>                   <span class="at">as.data.frame =</span> <span class="cn">TRUE</span>, <span class="at">extended=</span><span class="cn">TRUE</span>)</span>
<span id="cb5-3"><a href="#cb5-3" aria-hidden="true" tabindex="-1"></a><span class="sc">&gt;</span> <span class="fu">sapply</span>(A[<span class="dv">6</span><span class="sc">:</span><span class="dv">9</span>, <span class="dv">3</span><span class="sc">:</span><span class="dv">4</span>], <span class="st">&quot;class&quot;</span>)</span>
<span id="cb5-4"><a href="#cb5-4" aria-hidden="true" tabindex="-1"></a>       rows        cols           b           c</span>
<span id="cb5-5"><a href="#cb5-5" aria-hidden="true" tabindex="-1"></a>  <span class="st">&quot;integer&quot;</span>   <span class="st">&quot;integer&quot;</span>   <span class="st">&quot;numeric&quot;</span> <span class="st">&quot;character&quot;</span></span>
<span id="cb5-6"><a href="#cb5-6" aria-hidden="true" tabindex="-1"></a><span class="sc">&gt;</span></span></code></pre></div>
<p>Consistent with the <code>data.frame</code> semantics, <em>now</em>
requesting a named column <em>reduces to a vector</em> as this happens
at the R side:</p>
<pre><code>&gt; A[6:9, 3:4]$b
[1] 114.5 115.0 117.0 117.5 119.5 120.0 122.0 122.5
&gt;</code></pre>
<h1 id="sparse-arrays">Sparse Arrays</h1>
<h2 id="basic-reading-and-writing-of-sparse-arrays">Basic Reading and
Writing of Sparse Arrays</h2>
<p><em>Simple Examples</em></p>
<p>Basic reading returns the coordinates and any attributes. The
following examples use the array created by the <a href="https://github.com/TileDB-Inc/TileDB/blob/dev/examples/cpp_api/quickstart_sparse.cc">quickstart_sparse</a>
example.</p>
<div class="sourceCode" id="cb7"><pre class="sourceCode r"><code class="sourceCode r"><span id="cb7-1"><a href="#cb7-1" aria-hidden="true" tabindex="-1"></a><span class="sc">&gt;</span> A <span class="ot">&lt;-</span> <span class="fu">tiledb_array</span>(<span class="at">uri =</span> uri, <span class="at">is.sparse =</span> <span class="cn">TRUE</span>)</span>
<span id="cb7-2"><a href="#cb7-2" aria-hidden="true" tabindex="-1"></a><span class="sc">&gt;</span> A[]</span>
<span id="cb7-3"><a href="#cb7-3" aria-hidden="true" tabindex="-1"></a><span class="sc">$</span>rows</span>
<span id="cb7-4"><a href="#cb7-4" aria-hidden="true" tabindex="-1"></a>[<span class="dv">1</span>] <span class="dv">1</span> <span class="dv">2</span> <span class="dv">2</span></span>
<span id="cb7-5"><a href="#cb7-5" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb7-6"><a href="#cb7-6" aria-hidden="true" tabindex="-1"></a><span class="sc">$</span>cols</span>
<span id="cb7-7"><a href="#cb7-7" aria-hidden="true" tabindex="-1"></a>[<span class="dv">1</span>] <span class="dv">1</span> <span class="dv">3</span> <span class="dv">4</span></span>
<span id="cb7-8"><a href="#cb7-8" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb7-9"><a href="#cb7-9" aria-hidden="true" tabindex="-1"></a><span class="sc">$</span>a</span>
<span id="cb7-10"><a href="#cb7-10" aria-hidden="true" tabindex="-1"></a>[<span class="dv">1</span>] <span class="dv">1</span> <span class="dv">3</span> <span class="dv">2</span></span>
<span id="cb7-11"><a href="#cb7-11" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb7-12"><a href="#cb7-12" aria-hidden="true" tabindex="-1"></a><span class="sc">&gt;</span></span></code></pre></div>
<p>We can also request a <code>data.frame</code> object, either when
opening or by changing this object characteristic on the fly:</p>
<div class="sourceCode" id="cb8"><pre class="sourceCode r"><code class="sourceCode r"><span id="cb8-1"><a href="#cb8-1" aria-hidden="true" tabindex="-1"></a><span class="sc">&gt;</span> <span class="fu">return.data.frame</span>(A) <span class="ot">&lt;-</span> <span class="cn">TRUE</span></span>
<span id="cb8-2"><a href="#cb8-2" aria-hidden="true" tabindex="-1"></a><span class="sc">&gt;</span> A[]</span>
<span id="cb8-3"><a href="#cb8-3" aria-hidden="true" tabindex="-1"></a>  a rows cols</span>
<span id="cb8-4"><a href="#cb8-4" aria-hidden="true" tabindex="-1"></a><span class="dv">1</span> <span class="dv">1</span>    <span class="dv">1</span>    <span class="dv">1</span></span>
<span id="cb8-5"><a href="#cb8-5" aria-hidden="true" tabindex="-1"></a><span class="dv">2</span> <span class="dv">3</span>    <span class="dv">2</span>    <span class="dv">3</span></span>
<span id="cb8-6"><a href="#cb8-6" aria-hidden="true" tabindex="-1"></a><span class="dv">3</span> <span class="dv">2</span>    <span class="dv">2</span>    <span class="dv">4</span></span></code></pre></div>
<p>For sparse arrays, the return type is by default ‘extended’ showing
rows and column but this can be overridden.</p>
<p>Assignment works similarly:</p>
<div class="sourceCode" id="cb9"><pre class="sourceCode r"><code class="sourceCode r"><span id="cb9-1"><a href="#cb9-1" aria-hidden="true" tabindex="-1"></a><span class="sc">&gt;</span> A[<span class="dv">4</span>,<span class="dv">2</span>] <span class="ot">&lt;-</span> 42L</span>
<span id="cb9-2"><a href="#cb9-2" aria-hidden="true" tabindex="-1"></a><span class="sc">&gt;</span> A[]</span>
<span id="cb9-3"><a href="#cb9-3" aria-hidden="true" tabindex="-1"></a><span class="sc">&gt;</span> A[]</span>
<span id="cb9-4"><a href="#cb9-4" aria-hidden="true" tabindex="-1"></a>  rows cols  a</span>
<span id="cb9-5"><a href="#cb9-5" aria-hidden="true" tabindex="-1"></a><span class="dv">1</span>    <span class="dv">1</span>    <span class="dv">1</span>  <span class="dv">1</span></span>
<span id="cb9-6"><a href="#cb9-6" aria-hidden="true" tabindex="-1"></a><span class="dv">2</span>    <span class="dv">2</span>    <span class="dv">3</span>  <span class="dv">3</span></span>
<span id="cb9-7"><a href="#cb9-7" aria-hidden="true" tabindex="-1"></a><span class="dv">3</span>    <span class="dv">2</span>    <span class="dv">4</span>  <span class="dv">2</span></span>
<span id="cb9-8"><a href="#cb9-8" aria-hidden="true" tabindex="-1"></a><span class="dv">4</span>    <span class="dv">4</span>    <span class="dv">2</span> <span class="dv">42</span></span>
<span id="cb9-9"><a href="#cb9-9" aria-hidden="true" tabindex="-1"></a><span class="sc">&gt;</span></span></code></pre></div>
<p>Reads can select rows and or columns:</p>
<div class="sourceCode" id="cb10"><pre class="sourceCode r"><code class="sourceCode r"><span id="cb10-1"><a href="#cb10-1" aria-hidden="true" tabindex="-1"></a><span class="sc">&gt;</span> A[<span class="dv">2</span>,]</span>
<span id="cb10-2"><a href="#cb10-2" aria-hidden="true" tabindex="-1"></a>  rows cols a</span>
<span id="cb10-3"><a href="#cb10-3" aria-hidden="true" tabindex="-1"></a><span class="dv">1</span>    <span class="dv">2</span>    <span class="dv">3</span> <span class="dv">3</span></span>
<span id="cb10-4"><a href="#cb10-4" aria-hidden="true" tabindex="-1"></a><span class="dv">2</span>    <span class="dv">2</span>    <span class="dv">4</span> <span class="dv">2</span></span>
<span id="cb10-5"><a href="#cb10-5" aria-hidden="true" tabindex="-1"></a><span class="sc">&gt;</span> A[,<span class="dv">2</span>]</span>
<span id="cb10-6"><a href="#cb10-6" aria-hidden="true" tabindex="-1"></a>  rows cols  a</span>
<span id="cb10-7"><a href="#cb10-7" aria-hidden="true" tabindex="-1"></a><span class="dv">1</span>    <span class="dv">4</span>    <span class="dv">2</span> <span class="dv">42</span></span>
<span id="cb10-8"><a href="#cb10-8" aria-hidden="true" tabindex="-1"></a><span class="sc">&gt;</span></span></code></pre></div>
<p>Attributes can be selected similarly.</p>
<h2 id="datetime-attributes">Date(time) Attributes</h2>
<p>Similar to the dense array case described earlier, the file <a href="https://github.com/TileDB-Inc/TileDB-R/blob/master/inst/examples/ex_2.R">ex_2.R</a>
illustrates some basic operations on sparse arrays. It also shows date
and datetime types instead of just integer and double precision
floats.</p>
<div class="sourceCode" id="cb11"><pre class="sourceCode r"><code class="sourceCode r"><span id="cb11-1"><a href="#cb11-1" aria-hidden="true" tabindex="-1"></a><span class="sc">&gt;</span> A <span class="ot">&lt;-</span> <span class="fu">tiledb_array</span>(<span class="at">uri =</span> uri, <span class="at">as.data.frame =</span> <span class="cn">TRUE</span>)</span>
<span id="cb11-2"><a href="#cb11-2" aria-hidden="true" tabindex="-1"></a><span class="sc">&gt;</span> A[<span class="dv">1577858403</span><span class="sc">:</span><span class="dv">1577858408</span>]</span>
<span id="cb11-3"><a href="#cb11-3" aria-hidden="true" tabindex="-1"></a>        rows cols a   b          d                       e</span>
<span id="cb11-4"><a href="#cb11-4" aria-hidden="true" tabindex="-1"></a><span class="dv">1</span> <span class="dv">1577858403</span>    <span class="dv">1</span> <span class="dv">3</span> <span class="dv">103</span> <span class="dv">2020-01-11</span> <span class="dv">2020-01-02</span> <span class="dv">18</span><span class="sc">:</span><span class="dv">24</span><span class="sc">:</span><span class="fl">33.844</span></span>
<span id="cb11-5"><a href="#cb11-5" aria-hidden="true" tabindex="-1"></a><span class="dv">2</span> <span class="dv">1577858404</span>    <span class="dv">1</span> <span class="dv">4</span> <span class="dv">104</span> <span class="dv">2020-01-15</span> <span class="dv">2020-01-05</span> <span class="dv">02</span><span class="sc">:</span><span class="dv">28</span><span class="sc">:</span><span class="fl">36.214</span></span>
<span id="cb11-6"><a href="#cb11-6" aria-hidden="true" tabindex="-1"></a><span class="dv">3</span> <span class="dv">1577858405</span>    <span class="dv">1</span> <span class="dv">5</span> <span class="dv">105</span> <span class="dv">2020-01-19</span> <span class="dv">2020-01-05</span> <span class="dv">00</span><span class="sc">:</span><span class="dv">44</span><span class="sc">:</span><span class="fl">04.805</span></span>
<span id="cb11-7"><a href="#cb11-7" aria-hidden="true" tabindex="-1"></a><span class="dv">4</span> <span class="dv">1577858406</span>    <span class="dv">1</span> <span class="dv">6</span> <span class="dv">106</span> <span class="dv">2020-01-21</span> <span class="dv">2020-01-06</span> <span class="dv">12</span><span class="sc">:</span><span class="dv">58</span><span class="sc">:</span><span class="fl">51.770</span></span>
<span id="cb11-8"><a href="#cb11-8" aria-hidden="true" tabindex="-1"></a><span class="dv">5</span> <span class="dv">1577858407</span>    <span class="dv">1</span> <span class="dv">7</span> <span class="dv">107</span> <span class="dv">2020-01-25</span> <span class="dv">2020-01-09</span> <span class="dv">04</span><span class="sc">:</span><span class="dv">29</span><span class="sc">:</span><span class="fl">56.309</span></span>
<span id="cb11-9"><a href="#cb11-9" aria-hidden="true" tabindex="-1"></a><span class="dv">6</span> <span class="dv">1577858408</span>    <span class="dv">1</span> <span class="dv">8</span> <span class="dv">108</span> <span class="dv">2020-01-26</span> <span class="dv">2020-01-07</span> <span class="dv">13</span><span class="sc">:</span><span class="dv">55</span><span class="sc">:</span><span class="fl">10.240</span></span>
<span id="cb11-10"><a href="#cb11-10" aria-hidden="true" tabindex="-1"></a><span class="sc">&gt;</span></span></code></pre></div>
<p>The row coordinate is currently a floating point representation of
the underlying time type. We can both select attributes (here we
excluded the “a” column) and select rows by time (as the time stamps get
converted to the required floating point value).</p>
<div class="sourceCode" id="cb12"><pre class="sourceCode r"><code class="sourceCode r"><span id="cb12-1"><a href="#cb12-1" aria-hidden="true" tabindex="-1"></a><span class="sc">&gt;</span> <span class="fu">attrs</span>(A) <span class="ot">&lt;-</span> <span class="fu">c</span>(<span class="st">&quot;b&quot;</span>, <span class="st">&quot;d&quot;</span>, <span class="st">&quot;e&quot;</span>)</span>
<span id="cb12-2"><a href="#cb12-2" aria-hidden="true" tabindex="-1"></a><span class="sc">&gt;</span> A[<span class="fu">as.POSIXct</span>(<span class="st">&quot;2020-01-01&quot;</span>)<span class="sc">:</span><span class="fu">as.POSIXct</span>(<span class="st">&quot;2020-01-01 00:00:03&quot;</span>)]</span>
<span id="cb12-3"><a href="#cb12-3" aria-hidden="true" tabindex="-1"></a>        rows cols   b          d                       e</span>
<span id="cb12-4"><a href="#cb12-4" aria-hidden="true" tabindex="-1"></a><span class="dv">1</span> <span class="dv">1577858401</span>    <span class="dv">1</span> <span class="dv">101</span> <span class="dv">2020-01-05</span> <span class="dv">2020-01-01</span> <span class="dv">03</span><span class="sc">:</span><span class="dv">03</span><span class="sc">:</span><span class="fl">07.548</span></span>
<span id="cb12-5"><a href="#cb12-5" aria-hidden="true" tabindex="-1"></a><span class="dv">2</span> <span class="dv">1577858402</span>    <span class="dv">1</span> <span class="dv">102</span> <span class="dv">2020-01-10</span> <span class="dv">2020-01-02</span> <span class="dv">21</span><span class="sc">:</span><span class="dv">02</span><span class="sc">:</span><span class="fl">19.747</span></span>
<span id="cb12-6"><a href="#cb12-6" aria-hidden="true" tabindex="-1"></a><span class="dv">3</span> <span class="dv">1577858403</span>    <span class="dv">1</span> <span class="dv">103</span> <span class="dv">2020-01-11</span> <span class="dv">2020-01-02</span> <span class="dv">18</span><span class="sc">:</span><span class="dv">24</span><span class="sc">:</span><span class="fl">33.844</span></span>
<span id="cb12-7"><a href="#cb12-7" aria-hidden="true" tabindex="-1"></a><span class="sc">&gt;</span></span></code></pre></div>
<p>More extended examples are available showing indexing by date(time)
as well as character dimension.</p>
<h1 id="additional-information">Additional Information</h1>
<p>The TileDB R package is documented via R help functions
(<em>e.g.</em> <code>help(&quot;tiledb_array&quot;)</code> shows information for
the <code>tiledb_array()</code> function) as well as via a <a href="https://tiledb-inc.github.io/TileDB-R/">website regrouping all
documentation</a>. Extended <a href="https://tiledb-inc.github.io/TileDB-R/documentation.html">API
documentation</a> is available, as is a <a href="https://github.com/TileDB-Inc/TileDB-R/tree/master/inst/examples">examples/</a>
directory.</p>
<p>TileDB itself has extensive <a href="https://docs.tiledb.com/developer/installation">installation</a>,
and <a href="https://docs.tiledb.com/developer/">overall
documentation</a> as well as a <a href="https://forum.tiledb.com/">support forum</a>.</p>
</body>
</html>
